#include <stdio.h>
#include <string.h>

typedef struct FichaAlumno {
	char apellidos[30];
	char nombre[15];
	unsigned char edad;
	float talla;
} FichaAlumno;

FichaAlumno lista[] = { { "Garca Prez", "Primero", 19, 1.80 }, {
		"Rodrguez Rodrguez", "Segundo", 17, 1.62 }, { "Garca Prez",
		"Tercero", 19, 1.80 }, { "", "", 0, 0 } };

void imprimir(FichaAlumno * p);

int main(int argc, char *argv[]) {
	FichaAlumno * p = lista; /* es como si pusiramos p = &lista[0] */
	int numElementos = 3;
	/*
	 Primer iterador
	 */
	int i;
	for (i = 0; i < numElementos; i++) {
		imprimir(&lista[i]);
	}
	printf("\n");
	/*
	 Segundo iterador
	 */
	for (i = 0; i < numElementos; i++) {
		imprimir(p + i);
	}
	printf("\n");
	/*
	 Tercer iterador
	 */
	for (i = 0; i < numElementos; i++) {
		imprimir(p++);
	}
	printf("\n");
	/*
	 Cuarto iterador
	 */
	p = lista;
	while (strlen(p->apellidos)) /* Se prohibe que los apellidos estn en blanco */
	{
		imprimir(p++);
	}
	printf("\n");
	return 0;
}

void imprimir(FichaAlumno * p) {
	printf("%10u%30s%16s%4d%6.2f\n", (unsigned int)p, p->apellidos, p->nombre, p->edad,
			p->talla);
}
