#include <stdio.h>
#include <ctype.h>
#include <coti/utiles.h>

charRef abrir(charRef);
charRef mostrar(charRef);
charRef salir(charRef);

int main(int argc, char *argv[]) {
	/*
	 Declaracin de variables especficas de este programa.
	 */
	charRef nombreDelArchivo;
	charRef contenidoDelArchivo;
	/*
	 Declaracin de variables generales de esta arquitectura.
	 La arquitectura que se est utilizando es excesivamente sencilla,
	 vase ms adelante.
	 */
	charRef menu = "a) Abrir un fichero m) Mostrarlo en \
pantalla s) Salir";
	charRef titulo =
			"\n\nVisor de archivos de texto\n\
==========================\n\n";
	charRef orden;
	char opcion;

	printf(titulo);
	do {
		printf("%s ", menu);
		orden = sgets();
		opcion = toupper(orden[0]);
		switch (opcion) {
		case 'A':
			nombreDelArchivo = pedir("Ruta del archivo:");
			if (nombreDelArchivo)
				contenidoDelArchivo = abrir(nombreDelArchivo);
			break;
		case 'M':
			if (contenidoDelArchivo)
				mostrar(contenidoDelArchivo);
			break;
		case 'S':
			printf("\n\nSaliendo...\n\n");
			break;
		default:
			printf("\n\nOpcin desconocida\n\n%c", 7);
			break;
		}
	} while ('S' != opcion);
	return 0;
}

charRef abrir(charRef nombreDelArchivo) {
	FILE * fp = fopen(nombreDelArchivo, "r");
	charRef p = NULL;
	int longitudDelArchivo;
	if (fp) {
		fseek(fp, 0L, SEEK_END);
		longitudDelArchivo = ftell(fp);
		p = malloc(longitudDelArchivo);
		rewind(fp);
		fread(p, 1, longitudDelArchivo, fp);
		fclose(fp);
	} else {
		printf(
				"\n\nNo se puede leer el archivo, o \
el archivo est vaco.\n\n");
		p = NULL;
	}
	return p;
}
charRef mostrar(charRef contenidoDelArchivo) {
	puts(contenidoDelArchivo);
	return contenidoDelArchivo;
}
