#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <coti/utiles.h>

/*
	La forma de compilar esta funcin es:

+---------------+----------------------------------------------------------+
| Mac OS X	    | cc /usr/include/coti/utiles.o funcionconargumento.c      |
+---------------+----------------------------------------------------------+
| GCC Windows   | gcc -c C:\Dev-Cpp\include\coti\utiles.c                  |
|               | Ademas, es preciso aadir una instruccion en la linea de |
|               | ordenes del enlazador. La orden es la siguiente:         |
|               | C:\Dev-Cpp\include\coti\utiles.o                         |
|               | Para dar esa orden, se utiliza la opcion de menu         |
|               | Tools\Compiler options\Compiler:Add these commands to the|
|               | linker command line.                                     |
+---------------+----------------------------------------------------------+

Para que esto funcione, es preciso haber situado antes los ficheros utiles.h y utiles.o en el subdirectorio coti. Este directorio se halla en la ruta siguiente:
+---------------+----------------------------------------------------------+
| Mac OS X	    | /usr/include/coti                                        |
+---------------+----------------------------------------------------------+
| GCC Windows   | C:\Dev-Cpp\include\coti                                  |
+---------------+----------------------------------------------------------+
*/
int contar_caracteres(char *);

int main(int argc, char *argv[])
{
  char * cadena;
  int longitud_de_cadena;
  printf("\n\nRecuento de caracteres\n======================\n\n");
  printf("Por favor escriba una frase: ");
  cadena = sgets();
  longitud_de_cadena = contar_caracteres(cadena);
  printf("\n\nLa longitud de la frase \"%s\" es %d\n\n",
                                          cadena,
                                          longitud_de_cadena);
  //system("pause");
  return 0;
}

int contar_caracteres(char * p)
{
  int resultado = 0;
  while( *p != '\0')
    {
      resultado++;
      p++;
    }
  return resultado;
}
