#include "utiles.h"

charRef sgets(void)
{
  charRef temp = malloc(1024);
  charRef p;
  fgets(temp,1024,stdin);
  if (p = strchr(temp, '\n')) *p = '\0';
  return temp;
}

charRef pedir(charRef indicacion)
{
	printf("%s ",indicacion);
	return sgets();
}

int pedirInt(charRef indicacion,int limInf,int limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	int numero;
	do
		{
			numero = limInf-1;
			printf("(%d <= x <= %d) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtol(linea,&temp, 10);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}
float pedirFloat(charRef indicacion,float limInf,float limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	float numero;
	do
		{
			numero = limInf -1.0;
			printf("(%.2f <= x <= %.2f) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtof(linea,&temp);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}
double pedirDouble(charRef indicacion,double limInf,double limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	double numero;
	do
		{
			numero = limInf -1.0;
			printf("(%.2f <= x <= %.2f) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtof(linea,&temp);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}