#include <stdio.h>
#include <coti/utiles.h>

typedef void (*pfun)(intRef);

void iterador(intRef, int, pfun);
void imprimir(intRef);

int main(int argc, char * argv[])
{
	int     numElementos = 0;
	intRef  lista        = NULL;
	int i;
	
	numElementos = pedirInt("Cuntos elementos tiene la lista?",1,10);
	
	lista        = malloc(sizeof(int)*numElementos);
	
	for(i=0;i<numElementos;i++) lista[i] = i;
	
	iterador(lista,numElementos,imprimir);
	
	return 0;
}

void iterador(intRef pBloque, int numElementos, pfun f)
{
	int i;
	for(i=0;i<numElementos;i++) f(pBloque+i);
}

void imprimir(intRef pn)
{
	printf("|%4d|\n",*pn);
}
