/*
 i ^ j = k
 j ^ k = i
 k ^ i = j
 */
#include <stdio.h>
#include <math.h>
#include <coti/utiles.h>

floatRef crossprod(floatRef v1, floatRef v2);

int main(int n, char * p[]) {
	float v1[3];
	float v2[3];
	floatRef v3;
	char peticion[32];
	int i;
	printf("\n\nProducto vectorial\n==================\n\n");
	printf("Coordenadas del primer vector:\n\n");
	for (i = 0; i < 3; i++) {
		sprintf(peticion, "v1[%d] = ", i);
		v1[i] = pedirFloat(peticion, -HUGE_VALF, HUGE_VALF);
	}
	printf("\n\nCoordenadas del segundo vector:\n\n");
	for (i = 0; i < 3; i++) {
		sprintf(peticion, "v2[%d] = ", i);
		v2[i] = pedirFloat(peticion, -HUGE_VALF, HUGE_VALF);
	}
	v3 = crossprod(v1, v2);
	printf(
			"\n\n(%6.2f, %6.2f, %6.2f) X (%6.2f, %6.2f, %6.2f) \
= (%6.2f, %6.2f, %6.2f) \n\n",
			v1[0], v1[1], v1[2], v2[0], v2[1], v2[2], v3[0], v3[1], v3[2]);
	return 0;
}

floatRef crossprod(floatRef v1, floatRef v2) {
	floatRef r = malloc(3* sizeof (float));
	r[0] = v1[1]*v2[2]-v1[2]*v2[1];
	r[1] = v1[2]*v2[0]-v1[0]*v2[2];
	r[2] = v1[0]*v2[1]-v1[1]*v2[0];
	return r;
}
