#include <stdio.h>
#include <coti/utiles.h>

void funcionQueRecibeUnPunteroDeVariable( intRef);

int main(int argc, char *argv[]) {
	int variableLocal;
	intRef direccionDeVariableLocal = &variableLocal;
	variableLocal = 33;
	printf("\n\nEl valor inicial de la variable local es %d\n\n", variableLocal);
	printf("La direccin de variableLocal es %u\n\n", (unsigned int)direccionDeVariableLocal);
	funcionQueRecibeUnPunteroDeVariable(direccionDeVariableLocal);
	printf(
			"Despus de llamar a la funcin, el valor de variableLocal es: %d\n\n",
			variableLocal);
	printf("Ahora damos a variableLocal el valor 968\n\n");
	variableLocal = 968;
	printf("Hemos dado a variable local el valor %d\n\n", variableLocal);
	funcionQueRecibeUnPunteroDeVariable(&variableLocal);
	printf(
			"\n\nY una vez ms, a la vuelta de la funcin, variableLocal = %d\n\n",
			variableLocal);
	return 0;
}

void funcionQueRecibeUnPunteroDeVariable(intRef p) {
	/*
	 El puntero p contiene la direccin de variableLocal
	 porque el valor del parmetro real se copia en el parmetro formal
	 */
	printf("Dentro de la funcin, el valor de p es %u\n\n", (unsigned int)p);
	*p = 123456789;
	printf("Damos a *p el valor 123456789\n\n");
	return;
}
