#include <stdio.h>
#include <coti/utiles.h>
#include <errno.h>
/*
 * Problema: strsep() no resulta conocido para MinGW.
 * Hay que volver a strtok.
 */
int main(int argc, char * argv[])
{
	charRef * ldc = NULL;
	int i;
	charRef filename   = NULL;
	FILE * fp          = NULL;
	int numBytes       = 0;
	int numStrings     = 0;
	charRef contents   = NULL;
	charRef safetyCopy = NULL;
	char delim[]       = {'\1', '\0'};
	charRef temp       = NULL;
	filename = pedir("\nCual es el archivo de entrada? ");
	fp = fopen(filename,"r");
	if (!fp)
		{
			printf("\n%s - %s - Saliendo.\n\n",filename,strerror(errno));
			return 1;
		}
	fseek(fp,0L,SEEK_END);
	numBytes = ftell(fp);
	contents = malloc(numBytes);
	safetyCopy = contents; /* strsep modifica el ptro */
	rewind(fp);
	fread(contents,numBytes,1,fp);
	fclose(fp);
	for(i=0;i<numBytes;i++)
		if ('\0'==contents[i])
			{
				numStrings++;
				contents[i] = '\1';
			}

	printf("\nEl archivo contiene %d cadenas.\n\n",numStrings);
	ldc = malloc(numStrings*sizeof(charRef));
	i=0;
	do
	{
		temp = strsep(&contents,delim);
		ldc[i] = malloc(strlen(temp)+1);
		strcpy(ldc[i],temp);
		i++;
	} while (contents);

	printf("\nLas cadenas ledas son estas:\n\n");
	for(i=0;i<numStrings;i++)
		{
			puts(ldc[i]);
		}
	free(safetyCopy);
	return 0;
}
